"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createASTNNormalizer = void 0;
const pr = __importStar(require("pareto-runtime"));
const stringSerialization = __importStar(require("./stringSerialization"));
function createASTNNormalizer($, $p) {
    function createIndentation(context) {
        const depth = context.dictionaryDepth + context.verboseGroupDepth + context.listDepth;
        let indentation = $.newline;
        for (let x = 0; x !== depth; x += 1) {
            indentation += $.indentationString;
        }
        return indentation;
    }
    return {
        objectBegin: ($) => {
            $p.writer.token({
                stringBefore: ``,
                token: `${$.token.token.type[0] === "verbose group" ? "(" : "{"}`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        property: ($) => {
            $p.writer.token({
                stringBefore: `${createIndentation($.stackContext)}`,
                token: (() => {
                    switch ($.objectToken.token.type[0]) {
                        case "verbose group": {
                            return stringSerialization.createSerializedApostrophedString($.propertyToken.token.value);
                        }
                        case "dictionary": {
                            return stringSerialization.createSerializedQuotedString($.propertyToken.token.value);
                        }
                        default:
                            return pr.au($.objectToken.token.type[0]);
                    }
                })(),
                stringAfter: `: `,
            }, $.propertyToken.annotation);
        },
        objectEnd: ($) => {
            $p.writer.token({
                stringBefore: $.isEmpty ? ` ` : `${createIndentation($.stackContext)}`,
                token: `${$.openToken.token.type[0] === "verbose group" ? ")" : "}"}`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        arrayBegin: ($) => {
            $p.writer.token({
                stringBefore: ``,
                token: `${$.token.token.type[0] === "shorthand group" ? "<" : "["}`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        element: ($) => {
            $p.writer.nonToken({
                string: $.arrayToken.token.type[0] === "shorthand group"
                    ? ` `
                    : `${createIndentation($.stackContext)}`,
            });
        },
        arrayEnd: ($) => {
            $p.writer.token({
                stringBefore: $.openToken.token.type[0] === "shorthand group"
                    ? ` `
                    : $.isEmpty ? ` ` : `${createIndentation($.stackContext)}`,
                token: $.openToken.token.type[0] === "shorthand group"
                    ? `>`
                    : `]`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        simpleStringValue: ($) => {
            function serializeSimpleString($) {
                switch ($.wrapping[0]) {
                    case "none": {
                        return stringSerialization.createSerializedNonWrappedString($.value);
                    }
                    case "quote": {
                        return stringSerialization.createSerializedQuotedString($.value);
                    }
                    case "apostrophe": {
                        return stringSerialization.createSerializedApostrophedString($.value);
                    }
                    default:
                        return pr.au($.wrapping[0]);
                }
            }
            $p.writer.token({
                stringBefore: ``,
                token: serializeSimpleString($.token.token),
                stringAfter: ``,
            }, $.token.annotation);
        },
        multilineStringValue: ($) => {
            $p.writer.token({
                stringBefore: ``,
                token: stringSerialization.createSerializedMultilineString($.token.token.lines, createIndentation($.stackContext)),
                stringAfter: ``,
            }, $.token.annotation);
        },
        taggedUnionBegin: ($) => {
            $p.writer.token({
                stringBefore: ``,
                token: `|`,
                stringAfter: ` `,
            }, $.token.annotation);
        },
        option: ($) => {
            $p.writer.token({
                stringBefore: ``,
                token: stringSerialization.createSerializedApostrophedString($.token.token.value),
                stringAfter: ` `,
            }, $.token.annotation);
        },
        taggedUnionEnd: ($) => {
            $p.writer.nonToken({
                string: ``,
            });
        },
        end: () => {
            $p.writer.nonToken({
                string: $.newline,
            });
        },
    };
}
exports.createASTNNormalizer = createASTNNormalizer;
