"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createASTNSerializer = void 0;
const createAnnotater_1 = require("./createAnnotater");
const createASTNNormalizer_1 = require("./createASTNNormalizer");
const createTreeParser_1 = require("./createTreeParser");
function createASTNSerializer($) {
    const writer = {
        token: (instruction) => {
            $.write(instruction.stringBefore);
            $.write(instruction.token);
            $.write(instruction.stringAfter);
        },
        nonToken: (instruction) => {
            $.write(instruction.string);
        },
    };
    return {
        onNoInternalSchema: () => { },
        onEmbeddedSchema: (_range) => {
            $.write(`! `);
            return (0, createAnnotater_1.createAnnotater)((0, createASTNNormalizer_1.createASTNNormalizer)({
                indentationString: $.indentationString,
                newline: $.newline,
            }, {
                writer: writer,
            }));
        },
        onSchemaReference: ($$) => {
            $.write(`! ${$$.token.token.value}${$.newline}`);
        },
        onBody: () => {
            const x = (0, createTreeParser_1.createTreeParser)({
                handler: (0, createAnnotater_1.createAnnotater)((0, createASTNNormalizer_1.createASTNNormalizer)({
                    indentationString: $.indentationString,
                    newline: $.newline,
                }, {
                    writer: writer,
                })),
                onError: $.onError,
            });
            return x;
        },
    };
}
exports.createASTNSerializer = createASTNSerializer;
