"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAnnotater = void 0;
const pr = __importStar(require("pareto-runtime"));
// import * as tokenLevel from "../../interfaces/tokenLevel"
// import * as typed from "../../interfaces/typed"
// import * as typedTokenize from "../../interfaces/typedTokenize"
function createAnnotater(handler) {
    let dictionaryDepth = 0;
    let verboseGroupDepth = 0;
    let listDepth = 0;
    let shorthandGroupDepth = 0;
    let taggedUnionDepth = 0;
    function createStackContext() {
        return {
            dictionaryDepth: dictionaryDepth,
            verboseGroupDepth: verboseGroupDepth,
            listDepth: listDepth,
            shorthandGroupDepth: shorthandGroupDepth,
            taggedUnionDepth: taggedUnionDepth,
        };
    }
    function createDecoratedValue() {
        return {
            object: ($) => {
                switch ($.token.token.type[0]) {
                    case "dictionary": {
                        dictionaryDepth += 1;
                        break;
                    }
                    case "verbose group": {
                        verboseGroupDepth += 1;
                        break;
                    }
                    default:
                        pr.au($.token.token.type[0]);
                }
                handler.objectBegin({
                    token: $.token,
                    stackContext: createStackContext(),
                });
                let foundProperties = false;
                return {
                    property: ($$) => {
                        const wasFirst = !foundProperties;
                        foundProperties = true;
                        handler.property({
                            propertyToken: $$.token,
                            objectToken: $.token,
                            stackContext: createStackContext(),
                            isFirst: wasFirst,
                        });
                        return createDecoratedRequiredValue();
                    },
                    onEnd: ($$) => {
                        switch ($.token.token.type[0]) {
                            case "dictionary": {
                                dictionaryDepth -= 1;
                                break;
                            }
                            case "verbose group": {
                                verboseGroupDepth -= 1;
                                break;
                            }
                            default:
                                pr.au($.token.token.type[0]);
                        }
                        handler.objectEnd({
                            openToken: $.token,
                            token: $$.token,
                            isEmpty: !foundProperties,
                            stackContext: createStackContext(),
                        });
                    },
                };
            },
            array: ($) => {
                switch ($.token.token.type[0]) {
                    case "list": {
                        listDepth += 1;
                        break;
                    }
                    case "shorthand group": {
                        shorthandGroupDepth += 1;
                        break;
                    }
                    default:
                        pr.au($.token.token.type[0]);
                }
                handler.arrayBegin({
                    token: $.token,
                    stackContext: createStackContext(),
                });
                let foundElements = false;
                return {
                    element: ($$) => {
                        const wasFirst = !foundElements;
                        foundElements = true;
                        handler.element({
                            arrayToken: $.token,
                            stackContext: createStackContext(),
                            isFirst: wasFirst,
                        });
                        return createDecoratedValue();
                    },
                    onEnd: ($$) => {
                        switch ($.token.token.type[0]) {
                            case "list": {
                                listDepth -= 1;
                                break;
                            }
                            case "shorthand group": {
                                shorthandGroupDepth -= 1;
                                break;
                            }
                            default:
                                pr.au($.token.token.type[0]);
                        }
                        handler.arrayEnd({
                            openToken: $.token,
                            token: $$.token,
                            stackContext: createStackContext(),
                            isEmpty: !foundElements,
                        });
                    },
                };
            },
            simpleString: ($) => {
                handler.simpleStringValue({
                    token: $.token,
                    stackContext: createStackContext(),
                });
            },
            multilineString: ($) => {
                handler.multilineStringValue({
                    token: $.token,
                    stackContext: createStackContext(),
                });
            },
            taggedUnion: ($) => {
                taggedUnionDepth += 1;
                handler.taggedUnionBegin({
                    token: $.token,
                    stackContext: createStackContext(),
                });
                return {
                    option: ($$) => {
                        handler.option({
                            token: $$.token,
                            stackContext: createStackContext(),
                        });
                        return createDecoratedRequiredValue();
                    },
                    missingOption: () => { },
                    end: ($$) => {
                        taggedUnionDepth -= 1;
                        handler.taggedUnionEnd({
                            stackContext: createStackContext(),
                        });
                    },
                };
            },
        };
    }
    function createDecoratedRequiredValue() {
        return {
            exists: createDecoratedValue(),
            missing: () => { },
        };
    }
    return {
        root: createDecoratedRequiredValue(),
        onEnd: (annotation) => {
            handler.end(annotation);
        },
    };
}
exports.createAnnotater = createAnnotater;
