"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createExpectContext = void 0;
/* eslint
*/
const pr = __importStar(require("pareto-runtime"));
function createCreateContext(issueHandler, createDummyValueHandler, duplicateEntrySeverity, onDuplicateEntry) {
    function raiseWarning(issue, annotation) {
        issueHandler({
            issue: issue,
            severity: ["warning", {}],
            annotation: annotation,
        });
    }
    function raiseError(issue, annotation) {
        issueHandler({
            issue: issue,
            severity: ["error", {}],
            annotation: annotation,
        });
    }
    function createDummyRequiredValueHandler() {
        return {
            exists: createDummyValueHandler(),
            missing: () => { },
        };
    }
    return {
        createDictionaryHandler: (onEntry, onBegin, onEnd) => {
            return (data) => {
                if (data.token.token.type[0] !== "dictionary") {
                    raiseWarning(["object is not a dictionary", {}], data.token.annotation);
                }
                if (onBegin) {
                    onBegin(data);
                }
                const foundEntries = [];
                return {
                    property: (propertyData) => {
                        const process = () => {
                            if (foundEntries.includes(propertyData.token.token.value)) {
                                switch (duplicateEntrySeverity[0]) {
                                    case "error":
                                        raiseError(["duplicate entry", { key: propertyData.token.token.value }], propertyData.token.annotation);
                                        break;
                                    case "nothing":
                                        break;
                                    case "warning":
                                        raiseWarning(["duplicate entry", { key: propertyData.token.token.value }], propertyData.token.annotation);
                                        break;
                                    default:
                                        pr.au(duplicateEntrySeverity[0]);
                                }
                                switch (onDuplicateEntry[0]) {
                                    case "ignore":
                                        return createDummyRequiredValueHandler();
                                    case "overwrite":
                                        return onEntry(propertyData);
                                    default:
                                        return pr.au(onDuplicateEntry[0]);
                                }
                            }
                            else {
                                return onEntry(propertyData);
                            }
                        };
                        const vh = process();
                        foundEntries.push(propertyData.token.token.value);
                        return vh;
                    },
                    onEnd: (endData) => {
                        if (onEnd) {
                            onEnd(endData.token);
                        }
                    },
                };
            };
        },
        createVerboseGroupHandler: (expectedProperties, onBegin, onEnd, onUnexpectedProperty) => {
            const properties = expectedProperties ? expectedProperties : {};
            return (data) => {
                if (data.token.token.type[0] !== "verbose group") {
                    raiseWarning(["object is not a verbose group", {}], data.token.annotation);
                }
                if (onBegin) {
                    onBegin(data);
                }
                const foundProperies = [];
                let hasErrors = false;
                return {
                    property: ($$) => {
                        const onProperty = () => {
                            const expected = properties[$$.token.token.value];
                            if (expected === undefined) {
                                hasErrors = true;
                                raiseError(["unexpected property", {
                                        "found key": $$.token.token.value,
                                        "valid keys": pr.Objectkeys(properties).sort(),
                                    }], $$.token.annotation);
                                if (onUnexpectedProperty !== undefined) {
                                    return onUnexpectedProperty($$);
                                }
                                else {
                                    return {
                                        exists: createDummyValueHandler(),
                                        missing: () => { },
                                    };
                                }
                            }
                            return expected.onExists($$);
                        };
                        const process = () => {
                            if (foundProperies.includes($$.token.token.value)) {
                                switch (duplicateEntrySeverity[0]) {
                                    case "error":
                                        raiseError(["duplicate property", { name: $$.token.token.value }], $$.token.annotation);
                                        break;
                                    case "nothing":
                                        break;
                                    case "warning":
                                        raiseWarning(["duplicate property", { name: $$.token.token.value }], $$.token.annotation);
                                        break;
                                    default:
                                        return pr.au(duplicateEntrySeverity[0]);
                                }
                                switch (onDuplicateEntry[0]) {
                                    case "ignore":
                                        return createDummyRequiredValueHandler();
                                    case "overwrite":
                                        return onProperty();
                                    default:
                                        return pr.au(onDuplicateEntry[0]);
                                }
                            }
                            else {
                                return onProperty();
                            }
                        };
                        const vh = process();
                        foundProperies.push($$.token.token.value);
                        return vh;
                    },
                    onEnd: (endData) => {
                        pr.Objectkeys(properties).forEach((epName) => {
                            if (!foundProperies.includes(epName)) {
                                const ep = properties[epName];
                                if (ep.onNotExists === null) {
                                    raiseError(["missing property", { name: epName }], data.token.annotation); //FIX print location properly
                                    hasErrors = true;
                                }
                                else {
                                    ep.onNotExists({
                                        beginToken: data.token,
                                        endToken: endData.token,
                                    });
                                }
                            }
                        });
                        if (onEnd) {
                            onEnd({
                                hasErrors: hasErrors,
                                annotation: endData.token.annotation,
                            });
                        }
                    },
                };
            };
        },
        createShorthandGroupHandler: (expectedElements, onBegin, onEnd) => {
            const elements = expectedElements ? expectedElements : [];
            return (typeData) => {
                if (onBegin) {
                    onBegin(typeData);
                }
                if (typeData.token.token.type[0] !== "shorthand group") {
                    raiseWarning(["array is not a shorthand group", {}], typeData.token.annotation);
                }
                let index = 0;
                return {
                    element: () => {
                        const ee2 = pr.getElement(elements, index);
                        index++;
                        if (ee2 === undefined) {
                            const dvh = createDummyValueHandler();
                            return {
                                object: (data) => {
                                    raiseError(["superfluous element", {}], data.token.annotation);
                                    return dvh.object(data);
                                },
                                array: (data) => {
                                    raiseError(["superfluous element", {}], data.token.annotation);
                                    return dvh.array(data);
                                },
                                simpleString: (data) => {
                                    raiseError(["superfluous element", {}], data.token.annotation);
                                    return dvh.simpleString(data);
                                },
                                multilineString: (data) => {
                                    raiseError(["superfluous element", {}], data.token.annotation);
                                    return dvh.multilineString(data);
                                },
                                taggedUnion: (data) => {
                                    raiseError(["superfluous element", {}], data.token.annotation);
                                    return dvh.taggedUnion(data);
                                },
                            };
                        }
                        else {
                            return ee2.getHandler().exists;
                        }
                    },
                    onEnd: ($$) => {
                        const missing = elements.length - index;
                        if (missing > 0) {
                            raiseError(['elements missing', {
                                    names: elements.map((ee2) => {
                                        return ee2.name;
                                    }),
                                }], $$.token.annotation);
                            for (let x = index; x !== elements.length; x += 1) {
                                const ee2 = pr.getElement(elements, x);
                                ee2.getHandler().missing();
                            }
                        }
                        if (onEnd) {
                            onEnd($$.token);
                        }
                    },
                };
            };
        },
        createListHandler: (onElement, onBegin, onEnd) => {
            return (data) => {
                if (data.token.token.type[0] !== "list") {
                    raiseWarning(["array is not a list", {}], data.token.annotation);
                }
                if (onBegin) {
                    onBegin(data);
                }
                return {
                    element: () => onElement(),
                    onEnd: (endData) => {
                        if (onEnd) {
                            onEnd(endData.token);
                        }
                    },
                };
            };
        },
        createTaggedUnionHandler: (options, onUnexpectedOption, onMissingOption) => {
            return (tuData) => {
                return {
                    option: (optionData) => {
                        const optionHandler = options ? options[optionData.token.token.value] : undefined;
                        if (optionHandler === undefined) {
                            raiseError(["unknown option", {
                                    "found": optionData.token.token.value,
                                    "valid options": options ? pr.Objectkeys(options) : [],
                                }], optionData.token.annotation);
                            if (onUnexpectedOption !== undefined) {
                                onUnexpectedOption({
                                    taggedUnionToken: tuData.token,
                                    optionToken: optionData.token,
                                });
                            }
                            return createDummyRequiredValueHandler();
                        }
                        else {
                            return optionHandler(tuData.token, optionData.token);
                        }
                    },
                    missingOption: onMissingOption ? onMissingOption : () => { },
                    end: () => { },
                };
            };
        },
        createUnexpectedSimpleStringHandler: (expected, onInvalidType, onNull) => {
            return (svData) => {
                if (onNull !== undefined && svData.token.token.wrapping[0] === "none" && svData.token.token.value === "null") {
                    onNull(svData);
                }
                else {
                    if (onInvalidType !== undefined && onInvalidType !== null) {
                        onInvalidType({
                            annotation: svData.token.annotation,
                        });
                    }
                    else {
                        raiseError(["invalid value type", {
                                found: "string",
                                expected: expected,
                            }], svData.token.annotation);
                    }
                }
            };
        },
        createUnexpectedMultilineStringHandler: (expected, onInvalidType) => {
            return (svData) => {
                if (onInvalidType !== undefined && onInvalidType !== null) {
                    onInvalidType({
                        annotation: svData.token.annotation,
                    });
                }
                else {
                    raiseError(["invalid value type", {
                            found: "string",
                            expected: expected,
                        }], svData.token.annotation);
                }
            };
        },
        createNullHandler: (expected, onInvalidType) => {
            return (svData) => {
                if (onInvalidType !== undefined && onInvalidType !== null) {
                    onInvalidType({
                        annotation: svData.token.annotation,
                    });
                }
                else {
                    raiseError(["invalid value type", { found: "string", expected: expected }], svData.token.annotation);
                }
            };
        },
        createUnexpectedTaggedUnionHandler: (expected, onInvalidType) => {
            return () => {
                return {
                    option: ($) => {
                        if (onInvalidType !== undefined && onInvalidType !== null) {
                            onInvalidType({
                                annotation: $.token.annotation,
                            });
                        }
                        else {
                            raiseError(["invalid value type", { found: "tagged union", expected: expected }], $.token.annotation);
                        }
                        return createDummyRequiredValueHandler();
                    },
                    missingOption: () => { },
                    end: () => { },
                };
            };
        },
        createUnexpectedObjectHandler: (expected, onInvalidType) => {
            return ($) => {
                if (onInvalidType !== undefined && onInvalidType !== null) {
                    onInvalidType({
                        annotation: $.token.annotation,
                    });
                }
                else {
                    raiseError(["invalid value type", { found: "object", expected: expected }], $.token.annotation);
                }
                return {
                    property: (propertyData) => {
                        return {
                            exists: createDummyValueHandler(),
                            missing: () => { },
                        };
                    },
                    onEnd: (_endData) => { },
                };
            };
        },
        createUnexpectedArrayHandler: (expected, onInvalidType) => {
            return ($) => {
                if (onInvalidType !== undefined && onInvalidType !== null) {
                    onInvalidType({
                        annotation: $.token.annotation,
                    });
                }
                else {
                    raiseError(["invalid value type", { found: "array", expected: expected }], $.token.annotation);
                }
                return {
                    element: () => {
                        return createDummyValueHandler();
                    },
                    onEnd: (_endData) => { },
                };
            };
        },
    };
}
function createExpectContext($p) {
    function raiseError(issue, annotation) {
        $p.issueHandler({
            issue: issue,
            severity: ["error", {}],
            annotation: annotation,
        });
    }
    function raiseWarning(issue, annotation) {
        $p.issueHandler({
            issue: issue,
            severity: ["warning", {}],
            annotation: annotation,
        });
    }
    const createContext = createCreateContext($p.issueHandler, $p.createDummyValueHandler, $p.duplicateEntrySeverity, $p.onDuplicateEntry);
    function expectSimpleStringImp(expected, callback, onInvalidType) {
        return {
            array: createContext.createUnexpectedArrayHandler(expected, onInvalidType),
            object: createContext.createUnexpectedObjectHandler(expected, onInvalidType),
            simpleString: callback,
            multilineString: createContext.createUnexpectedMultilineStringHandler(expected, onInvalidType),
            taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expected, onInvalidType),
        };
    }
    return {
        expectSimpleString: ($) => {
            const expectValue = {
                "type": "string",
                "null allowed": $.onNull !== undefined,
            };
            return expectSimpleStringImp(expectValue, $.callback, $.onInvalidType);
        },
        expectQuotedString: ($) => {
            const expectValue = {
                "type": "quoted string",
                "null allowed": $.onNull !== undefined,
            };
            return expectSimpleStringImp(expectValue, ($$) => {
                if ($$.token.token.wrapping[0] !== "quote") {
                    if ($.warningOnly) {
                        raiseWarning(["string is not quoted", {}], $$.token.annotation);
                        return $.callback({
                            token: $$.token,
                        });
                    }
                    else {
                        if ($.onInvalidType) {
                            $.onInvalidType({
                                annotation: $$.token.annotation,
                            });
                        }
                        else {
                            raiseError(["string is not quoted", {}], $$.token.annotation);
                        }
                    }
                }
                else {
                    return $.callback({
                        token: $$.token,
                    });
                }
            }, $.onInvalidType);
        },
        expectNonWrappedString: ($) => {
            const expectValue = {
                "type": "nonwrapped string",
                "null allowed": $.onNull !== undefined,
            };
            return expectSimpleStringImp(expectValue, ($$) => {
                if ($$.token.token.wrapping[0] !== "none") {
                    if ($.warningOnly) {
                        raiseWarning(["string should not have quotes or apostrophes", {}], $$.token.annotation);
                        return $.callback({
                            token: $$.token,
                        });
                    }
                    else {
                        if ($.onInvalidType) {
                            $.onInvalidType({
                                annotation: $$.token.annotation,
                            });
                        }
                        else {
                            raiseError(["string should not have quotes or apostrophes", {}], $$.token.annotation);
                        }
                    }
                }
                else {
                    return $.callback({
                        token: $$.token,
                    });
                }
            }, $.onInvalidType);
        },
        expectDictionary: ($) => {
            const expectValue = {
                "type": "dictionary",
                "null allowed": false,
            };
            return {
                array: createContext.createUnexpectedArrayHandler(expectValue, $.onInvalidType),
                object: createContext.createDictionaryHandler($.onProperty, $.onBegin, $.onEnd),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expectValue, $.onInvalidType),
            };
        },
        expectVerboseGroup: ($) => {
            const expectValue = {
                "type": "verbose group",
                "null allowed": $.onNull !== undefined,
            };
            return {
                array: createContext.createUnexpectedArrayHandler(expectValue, $.onInvalidType),
                object: createContext.createVerboseGroupHandler($.properties, $.onBegin, $.onEnd, $.onUnexpectedProperty),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expectValue, $.onInvalidType),
            };
        },
        expectList: ($) => {
            const expectValue = {
                "type": "list",
                "null allowed": false,
            };
            return {
                array: createContext.createListHandler($.onElement, $.onBegin, $.onEnd),
                object: createContext.createUnexpectedObjectHandler(expectValue, $.onInvalidType),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expectValue, $.onInvalidType),
            };
        },
        expectShorthandGroup: ($) => {
            const expectValue = {
                "type": "shorthand group",
                "null allowed": $.onNull !== undefined,
            };
            return {
                array: createContext.createShorthandGroupHandler($.elements, $.onBegin, $.onEnd),
                object: createContext.createUnexpectedObjectHandler(expectValue, $.onInvalidType),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expectValue, $.onInvalidType),
            };
        },
        expectGroup: ($) => {
            const expectValue = {
                "type": "type or shorthand group",
                "null allowed": $.onNull !== undefined,
            };
            return {
                array: createContext.createShorthandGroupHandler($.elements, $.onShorthandGroupBegin, $.onShorthandGroupEnd),
                object: createContext.createVerboseGroupHandler($.properties, $.onTypeBegin, $.onTypeEnd, $.onUnexpectedProperty),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createUnexpectedTaggedUnionHandler(expectValue, $.onInvalidType),
            };
        },
        expectTaggedUnion: ($) => {
            const expectValue = {
                "type": "tagged union",
                "null allowed": $.onNull !== undefined,
            };
            return {
                array: createContext.createUnexpectedArrayHandler(expectValue, $.onInvalidType),
                object: createContext.createUnexpectedObjectHandler(expectValue, $.onInvalidType),
                simpleString: createContext.createUnexpectedSimpleStringHandler(expectValue, $.onInvalidType, $.onNull),
                multilineString: createContext.createUnexpectedMultilineStringHandler(expectValue, $.onInvalidType),
                taggedUnion: createContext.createTaggedUnionHandler($.options, $.onUnexpectedOption, $.onMissingOption),
            };
        },
    };
}
exports.createExpectContext = createExpectContext;
