"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFlattener = void 0;
const pr = __importStar(require("pareto-runtime"));
function createFlattener(parser) {
    function createLoggingRequiredValueHandler() {
        return {
            exists: createValueHandler(),
            missing: () => { },
        };
    }
    function onEvent(event, annotation) {
        parser.onToken({
            annotation: annotation,
            token: event,
        });
    }
    function doSimpleString($) {
        onEvent(["simple string", {
                value: $.token.value,
                wrapping: (() => {
                    switch ($.token.wrapping[0]) {
                        case "apostrophe":
                            return ["apostrophe", {}];
                        case "none":
                            return ["none", {}];
                        case "quote":
                            return ["quote", {}];
                        default:
                            return pr.au($.token.wrapping[0]);
                    }
                })(),
            }], $.annotation);
    }
    function createValueHandler() {
        return {
            array: ($) => {
                const open$ = $;
                onEvent(["structural", {
                        "type": (() => {
                            switch ($.token.token.type[0]) {
                                case "list":
                                    return ["open list", {}];
                                case "shorthand group":
                                    return ["open shorthand group", {}];
                                default:
                                    return pr.au($.token.token.type[0]);
                            }
                        })(),
                    }], $.token.annotation);
                return {
                    element: () => {
                        return createValueHandler();
                    },
                    onEnd: ($) => {
                        onEvent(["structural", {
                                "type": (() => {
                                    switch (open$.token.token.type[0]) {
                                        case "list":
                                            return ["close list", {}];
                                        case "shorthand group":
                                            return ["close shorthand group", {}];
                                        default:
                                            return pr.au(open$.token.token.type[0]);
                                    }
                                })(),
                            }], $.token.annotation);
                    },
                };
            },
            object: ($) => {
                const open$ = $;
                onEvent(["structural", {
                        "type": (() => {
                            switch ($.token.token.type[0]) {
                                case "dictionary":
                                    return ["open dictionary", {}];
                                case "verbose group":
                                    return ["open verbose group", {}];
                                default:
                                    return pr.au($.token.token.type[0]);
                            }
                        })(),
                    }], $.token.annotation);
                return {
                    property: ($) => {
                        doSimpleString($.token);
                        return createLoggingRequiredValueHandler();
                    },
                    onEnd: ($) => {
                        onEvent(["structural", {
                                "type": (() => {
                                    switch (open$.token.token.type[0]) {
                                        case "dictionary":
                                            return ["close dictionary", {}];
                                        case "verbose group":
                                            return ["close verbose group", {}];
                                        default:
                                            return pr.au(open$.token.token.type[0]);
                                    }
                                })(),
                            }], $.token.annotation);
                    },
                };
            },
            simpleString: ($) => {
                doSimpleString($.token);
            },
            multilineString: ($) => {
                onEvent(["multiline string", {
                        lines: $.token.token.lines.map(($) => {
                            return $;
                        }),
                    }], $.token.annotation);
            },
            taggedUnion: ($) => {
                onEvent(["structural", {
                        "type": ["tagged union start", {}],
                    }], $.token.annotation);
                return {
                    option: ($) => {
                        doSimpleString($.token);
                        return createLoggingRequiredValueHandler();
                    },
                    missingOption: () => { },
                    end: () => { },
                };
            },
        };
    }
    return {
        root: createLoggingRequiredValueHandler(),
        onEnd: (annotation) => {
            parser.onEnd(annotation);
        },
    };
}
exports.createFlattener = createFlattener;
