"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createJSONFormatter = void 0;
const pr = __importStar(require("pareto-runtime"));
const stringSerialization_1 = require("./stringSerialization");
function createJSONFormatter(indentationString, newline, writer) {
    function createIndentation(context) {
        let indentation = ``;
        for (let x = 0; x !== context.dictionaryDepth + context.verboseGroupDepth; x += 1) {
            indentation += indentationString;
        }
        return indentation;
    }
    return {
        objectBegin: ($) => {
            writer.token({
                stringBefore: ``,
                token: `{`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        property: ($) => {
            writer.token({
                stringBefore: `${$.isFirst ? "" : ","}${newline}${createIndentation($.stackContext)}`,
                token: (0, stringSerialization_1.createSerializedQuotedString)($.propertyToken.token.value),
                stringAfter: `: `,
            }, $.propertyToken.annotation);
        },
        objectEnd: ($) => {
            writer.token({
                stringBefore: $.isEmpty ? ` ` : `${newline}${createIndentation($.stackContext)}`,
                token: `}`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        arrayBegin: ($) => {
            writer.token({
                stringBefore: ``,
                token: `[`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        element: ($) => {
            writer.nonToken({
                string: `${$.isFirst ? "" : ","} `,
            });
        },
        arrayEnd: ($) => {
            writer.token({
                stringBefore: ` `,
                token: `]`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        simpleStringValue: ($) => {
            writer.token({
                stringBefore: ``,
                token: (() => {
                    switch ($.token.token.wrapping[0]) {
                        case "none": {
                            // if ($.token.data.value === "true" || $.token.data.value === "false" || $.token.data.value === "null") {
                            //     return $.token.data.value
                            // }
                            // //eslint-disable-next-line
                            // const nr = new Number($.token.data.value).valueOf()
                            // if (isNaN(nr)) {
                            //     return createSerializedQuotedString($.token.data.value)
                            // }
                            return (0, stringSerialization_1.createSerializedNonWrappedString)($.token.token.value);
                        }
                        case "quote": {
                            return (0, stringSerialization_1.createSerializedQuotedString)($.token.token.value);
                        }
                        case "apostrophe": {
                            return (0, stringSerialization_1.createSerializedQuotedString)($.token.token.value);
                        }
                        default:
                            return pr.au($.token.token.wrapping[0]);
                    }
                })(),
                stringAfter: ``,
            }, $.token.annotation);
        },
        multilineStringValue: ($) => {
            writer.token({
                stringBefore: ``,
                token: (0, stringSerialization_1.createSerializedQuotedString)($.token.token.lines.join(newline)),
                stringAfter: ``,
            }, $.token.annotation);
        },
        taggedUnionBegin: ($) => {
            writer.token({
                stringBefore: ``,
                token: `[`,
                stringAfter: ``,
            }, $.token.annotation);
        },
        option: ($) => {
            writer.token({
                stringBefore: ` `,
                token: (0, stringSerialization_1.createSerializedQuotedString)($.token.token.value),
                stringAfter: `, `,
            }, $.token.annotation);
        },
        taggedUnionEnd: ($) => {
            writer.nonToken({
                string: ` ]`,
            });
        },
        end: () => {
            writer.nonToken({
                string: newline,
            });
        },
    };
}
exports.createJSONFormatter = createJSONFormatter;
