"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createJSONSerializer = void 0;
const createAnnotater_1 = require("./createAnnotater");
const dummyHandlers_1 = require("./dummyHandlers");
const createJSONFormatter_1 = require("./createJSONFormatter");
const createTreeParser_1 = require("./createTreeParser");
function createJSONSerializer($) {
    return {
        onNoInternalSchema: () => { },
        onEmbeddedSchema: (_range) => {
            return (0, dummyHandlers_1.createDummyTreeHandler)();
        },
        onSchemaReference: () => { },
        onBody: () => {
            const x = (0, createTreeParser_1.createTreeParser)({
                handler: (0, createAnnotater_1.createAnnotater)((0, createJSONFormatter_1.createJSONFormatter)($.indentationString, $.newline, {
                    token: (instruction) => {
                        $.write(instruction.stringBefore);
                        $.write(instruction.token);
                        $.write(instruction.stringAfter);
                    },
                    nonToken: (instruction) => {
                        $.write(instruction.string);
                    },
                })),
                onError: $.onError,
            });
            return x;
        },
    };
}
exports.createJSONSerializer = createJSONSerializer;
