"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStructureParser = void 0;
const pr = __importStar(require("pareto-runtime"));
const createTreeParser_1 = require("./createTreeParser");
function createStructureParser($p) {
    const rootContext = { state: ["expecting header or body", {}] };
    return {
        onEnd: (annotation) => {
            function raiseError(error) {
                $p.onError({
                    error: ["structure", error],
                    annotation: annotation,
                });
            }
            switch (rootContext.state[0]) {
                case "expecting header or body": {
                    //const $ = rootContext.state[1]
                    raiseError(["expected the schema start (!) or root value", {}]);
                    break;
                }
                case "expecting schema reference or embedded schema": {
                    raiseError(["expected a schema reference or an embedded schema", {}]);
                    break;
                }
                case "expecting schema schema reference": {
                    raiseError(["expected a schema schema reference", {}]);
                    break;
                }
                case "processing embedded schema": {
                    const $$ = rootContext.state[1];
                    $$.schemaParser.onEnd(annotation);
                    break;
                }
                case "processing body": {
                    const $ = rootContext.state[1];
                    $.bodyParser.onEnd(annotation);
                    break;
                }
                default:
                    pr.au(rootContext.state[0]);
            }
        },
        onToken: ($) => {
            const data = $;
            function raiseError(error) {
                $p.onError({
                    error: ["structure", error],
                    annotation: $.annotation,
                });
            }
            switch (rootContext.state[0]) {
                case "expecting header or body": {
                    switch ($.token[0]) {
                        case "header start": {
                            rootContext.state = ["expecting schema reference or embedded schema", {
                                    headerAnnotation: $.annotation,
                                }];
                            break;
                        }
                        case "content": {
                            pr.cc($.token[1], ($) => {
                                $p.handler.onNoInternalSchema({});
                                const bp = $p.handler.onBody();
                                rootContext.state = ["processing body", {
                                        bodyParser: bp,
                                    }];
                                bp.onToken({
                                    annotation: data.annotation,
                                    token: $,
                                });
                            });
                            break;
                        }
                        default:
                            pr.au($.token[0]);
                    }
                    break;
                }
                case "expecting schema reference or embedded schema": {
                    const headerAnnotation = rootContext.state[1].headerAnnotation;
                    switch ($.token[0]) {
                        case "header start": {
                            rootContext.state = ["expecting schema schema reference", {
                                    headerAnnotation: headerAnnotation,
                                    embeddedSchemaAnnotation: $.annotation,
                                }];
                            break;
                        }
                        case "content": {
                            pr.cc($.token[1], ($) => {
                                switch ($[0]) {
                                    case "structural": {
                                        pr.cc($[1], ($) => {
                                            raiseError(["expected a schema reference or an embedded schema", {}]);
                                        });
                                        break;
                                    }
                                    case "simple string": {
                                        pr.cc($[1], ($) => {
                                            $p.handler.onSchemaReference({
                                                headerAnnotation: headerAnnotation,
                                                token: {
                                                    token: $,
                                                    annotation: data.annotation,
                                                },
                                            });
                                            rootContext.state = ["processing body", {
                                                    bodyParser: $p.handler.onBody(),
                                                }];
                                        });
                                        break;
                                    }
                                    case "multiline string": {
                                        pr.cc($[1], ($) => {
                                            raiseError(["expected an embedded schema", {}]);
                                        });
                                        break;
                                    }
                                    default:
                                        pr.au($[0]);
                                }
                            });
                            break;
                        }
                        default:
                            pr.au($.token[0]);
                    }
                    break;
                }
                case "expecting schema schema reference": {
                    const headerAnnotation = rootContext.state[1].headerAnnotation;
                    const embeddedSchemaAnnotation = rootContext.state[1].embeddedSchemaAnnotation;
                    if ($.token[0] !== "content" || $.token[1][0] !== "simple string") {
                        raiseError(["expected a schema schema reference", {}]);
                    }
                    else {
                        const x = $p.handler.onEmbeddedSchema({
                            headerAnnotation: headerAnnotation,
                            embeddedSchemaAnnotation: embeddedSchemaAnnotation,
                            schemaSchemaReferenceToken: {
                                token: $.token[1][1],
                                annotation: $.annotation,
                            },
                        });
                        rootContext.state = ["processing embedded schema", {
                                schemaParser: (0, createTreeParser_1.createTreeParser)({
                                    handler: {
                                        onEnd: ($) => {
                                            x.onEnd($);
                                            rootContext.state = ["processing body", {
                                                    bodyParser: $p.handler.onBody(),
                                                }];
                                        },
                                        root: x.root,
                                    },
                                    onError: $p.onError,
                                }),
                            }];
                    }
                    break;
                }
                case "processing embedded schema": {
                    const $ = rootContext.state[1];
                    if (data.token[0] !== "content") {
                        throw new Error("IMPLEMENT ME");
                    }
                    $.schemaParser.onToken({
                        annotation: data.annotation,
                        token: data.token[1],
                    });
                    break;
                }
                case "processing body": {
                    if (data.token[0] !== "content") {
                        throw new Error("IMPLEMENT ME");
                    }
                    const $ = rootContext.state[1];
                    $.bodyParser.onToken({
                        annotation: data.annotation,
                        token: data.token[1],
                    });
                    break;
                }
                default:
                    pr.au(rootContext.state[0]);
            }
        },
    };
}
exports.createStructureParser = createStructureParser;
