"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDummyTreeHandler = exports.createDummyObjectHandler = exports.createDummyArrayHandler = exports.createDummyTaggedUnionHandler = exports.createDummyValueHandler = exports.createDummyRequiredValueHandler = void 0;
function createDummyRequiredValueHandler() {
    return {
        exists: createDummyValueHandler(),
        missing: () => { },
    };
}
exports.createDummyRequiredValueHandler = createDummyRequiredValueHandler;
function createDummyValueHandler() {
    return {
        array: () => createDummyArrayHandler(),
        object: () => createDummyObjectHandler(),
        simpleString: () => { },
        multilineString: () => { },
        taggedUnion: () => createDummyTaggedUnionHandler(),
    };
}
exports.createDummyValueHandler = createDummyValueHandler;
function createDummyTaggedUnionHandler() {
    return {
        option: () => createDummyRequiredValueHandler(),
        missingOption: () => { },
        end: () => { },
    };
}
exports.createDummyTaggedUnionHandler = createDummyTaggedUnionHandler;
function createDummyArrayHandler() {
    return {
        element: () => createDummyValueHandler(),
        onEnd: () => { },
    };
}
exports.createDummyArrayHandler = createDummyArrayHandler;
function createDummyObjectHandler() {
    return {
        property: () => {
            return createDummyRequiredValueHandler();
        },
        onEnd: () => { },
    };
}
exports.createDummyObjectHandler = createDummyObjectHandler;
function createDummyTreeHandler() {
    return {
        root: createDummyRequiredValueHandler(),
        onEnd: () => { },
    };
}
exports.createDummyTreeHandler = createDummyTreeHandler;
