import * as astn from "../../interface";
import * as grammar from "../../../grammar/interface";
export declare type ValueType<EventAnnotation> = [
    "dicionary",
    astn.ExpectDictionaryParameters<EventAnnotation>
] | [
    "list",
    astn.ExpectListParameters<EventAnnotation>
] | [
    "quoted string",
    astn.ExpectQuotedStringParameters<EventAnnotation>
] | [
    "simple string",
    astn.ExpectStringParameters<EventAnnotation>
] | [
    "tagged union",
    astn.ExpectTaggedUnionParameters<EventAnnotation>
] | [
    "verbose group",
    astn.ExpectVerboseGroupParameters<EventAnnotation>
];
export declare function createRequiredValueHandler<EventAnnotation>(context: astn.IExpectContext<EventAnnotation>, valueType: ValueType<EventAnnotation>, onMissing?: () => void): grammar.IRequiredValueHandler<EventAnnotation>;
export declare function createValueHandler<EventAnnotation>(context: astn.IExpectContext<EventAnnotation>, valueType: ValueType<EventAnnotation>): grammar.IValueHandler<EventAnnotation>;
