"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.printExpectIssue = void 0;
const pr = __importStar(require("pareto-runtime"));
const printExpectedValue_1 = require("./printExpectedValue");
function printExpectIssue(issue) {
    switch (issue[0]) {
        case "array is not a list": {
            return `expected a list: [ ]`;
        }
        case "array is not a shorthand group": {
            return `expected a shorthand group: < >`;
        }
        case "object is not a dictionary": {
            return `expected a dictionary: { }`;
        }
        case "object is not a verbose group": {
            return `expected a verbose group: ( )`;
        }
        case "invalid value type": {
            const $ = issue[1];
            return `expected ${(0, printExpectedValue_1.printExpectedValue)($.expected)} but found ${(0, printExpectedValue_1.printExpectedValueType)($.found)}`;
        }
        case "invalid string": {
            const $ = issue[1];
            return `expected '${(0, printExpectedValue_1.printExpectedValue)($.expected)}' but found '${$.found}'`;
        }
        case "duplicate property": {
            const $ = issue[1];
            return `duplicate property: '${$.name}'`;
        }
        case "missing property": {
            const $ = issue[1];
            return `missing property: '${$.name}'`;
        }
        case "unexpected property": {
            const $ = issue[1];
            return `unexpected property: '${$["found key"]}'. Choose from ${$["valid keys"].map(($) => `'${$}'`).join(", ")}`;
        }
        case "duplicate entry": {
            const $ = issue[1];
            return `duplicate entry: '${$.key}'`;
        }
        case "expected token": {
            const $ = issue[1];
            const val = (() => {
                switch ($.token) {
                    case "open angle bracket": {
                        return '<';
                    }
                    case "open bracket": {
                        return '[';
                    }
                    case "close bracket": {
                        return ']';
                    }
                    case "close angle bracket": {
                        return '>';
                    }
                    case "open curly": {
                        return '{';
                    }
                    case "close curly": {
                        return '}';
                    }
                    case "open paren": {
                        return '(';
                    }
                    case "close paren": {
                        return ')';
                    }
                    default:
                        return pr.au($.token[0]);
                }
            })();
            return `expected '${val}' but found '${$.found}'`;
        }
        case "not a valid number": {
            const $ = issue[1];
            return `'${$.value}' is not a valid number`;
        }
        case "string is not quoted": {
            // const $ = issue[1]
            return `not a quoted string`;
        }
        case "string should not have quotes or apostrophes": {
            // const $ = issue[1]
            return `a string with quotes or apostrophes`;
        }
        case "superfluous element": {
            //const $ = issue[1]
            return `superfluous element`;
        }
        case "elements missing": {
            const $ = issue[1];
            return `${$.names.length} missing element(s): ${$.names.map(($) => `'${$}'`).join(", ")}`;
        }
        case "unknown option": {
            const $ = issue[1];
            return `unknown option '${$.found}', choose from ${$["valid options"].map(($) => `'${$}'`).join(", ")} `;
        }
        default:
            return pr.au(issue[0]);
    }
}
exports.printExpectIssue = printExpectIssue;
