"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.printExpectedValue = exports.printExpectedValueType = void 0;
const pr = __importStar(require("pareto-runtime"));
function printExpectedValueType(vt) {
    switch (vt) {
        case "array": {
            return `an array ([] or <>)`;
        }
        case "shorthand group": {
            return `a shorhand type (<>)`;
        }
        case "boolean": {
            return `a boolean (true/false)`;
        }
        case "dictionary": {
            return `a dictionary ( {} )`;
        }
        case "list": {
            return `a list ( [] )`;
        }
        case "nothing": {
            return `nothing`;
        }
        case "null": {
            return `'null'`;
        }
        case "number": {
            return `a number`;
        }
        case "object": {
            return `an object ( {} or () )`;
        }
        case "string": {
            return `a string (quoted, apostrophed, multiline or non wrapped (including a number, a keyword, a boolean)`;
        }
        case "quoted string": {
            return `a string with quotes`;
        }
        case "nonwrapped string": {
            return `a string without quotes or aposthropes`;
        }
        case "tagged union": {
            return `a tagged union ( | "statename" data )`;
        }
        case "type": {
            return `a type ( () )`;
        }
        case "type or shorthand group": {
            return `a type ( () ) or a shorhand type (<>)`;
        }
        case "verbose group": {
            return `a verbose group ( () )`;
        }
        default:
            return pr.au(vt[0]);
    }
}
exports.printExpectedValueType = printExpectedValueType;
function printExpectedValue(vt) {
    return `${printExpectedValueType(vt.type)}${vt["null allowed"] ? 'or null' : ''}`;
}
exports.printExpectedValue = printExpectedValue;
