"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.printTreeParserError = exports.printParsingError = void 0;
const pr = __importStar(require("pareto-runtime"));
const printStructureError_1 = require("./printStructureError");
function printParsingError(error) {
    switch (error[0]) {
        case "tree": {
            const $ = error[1];
            return printTreeParserError($);
        }
        case "structure": {
            const $ = error[1];
            return (0, printStructureError_1.printStructureError)($);
        }
        default:
            return pr.au(error[0]);
    }
}
exports.printParsingError = printParsingError;
function printTreeParserError(error) {
    switch (error[0]) {
        case "missing array close": {
            return error[0];
        }
        case "missing object close": {
            return error[0];
        }
        case "missing key": {
            return error[0];
        }
        case "missing option": {
            return error[0];
        }
        case "missing property value": {
            return error[0];
        }
        case "missing tagged union option and value": {
            return error[0];
        }
        case "missing tagged union value": {
            return error[0];
        }
        case "unexpected end of array": {
            return error[0];
        }
        case "unexpected end of text": {
            const $ = error[1];
            return `unexpected end of text, still in ${$["still in"][0]}`;
        }
        case "unexpected end of object": {
            return error[0];
        }
        case "unexpected data after end": {
            return error[0];
        }
        default:
            return pr.au(error[0]);
    }
}
exports.printTreeParserError = printTreeParserError;
