"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDummyTypedHandler = void 0;
function createDummyTypedHandler() {
    function createGroupNOPSideEffects() {
        return {
            onUnexpectedProperty: () => { },
            onProperty: () => {
                return createValueNOPSideEffects();
            },
            onClose: () => { },
        };
    }
    function createTaggedUnionNOPSideEffects() {
        return {
            onUnexpectedOption: () => {
                return createValueNOPSideEffects();
            }, onOption: () => {
                return createValueNOPSideEffects();
            }, onEnd: () => { },
        };
    }
    function createValueNOPSideEffects() {
        return {
            onDictionary: () => {
                return createDictionaryNOPSideEffects();
            },
            onList: () => {
                return createListNOPSideEffects();
            },
            onTaggedUnion: () => {
                return createTaggedUnionNOPSideEffects();
            },
            onSimpleString: () => { },
            onMultilineString: () => { },
            onTypeReference: () => {
                return createValueNOPSideEffects();
            }, onGroup: () => {
                return createGroupNOPSideEffects();
            },
        };
    }
    function createDictionaryNOPSideEffects() {
        return {
            onClose: () => { },
            onEntry: () => {
                return createValueNOPSideEffects();
            },
        };
    }
    function createListNOPSideEffects() {
        return {
            onClose: () => { },
            onElement: () => {
                return createValueNOPSideEffects();
            },
        };
    }
    return {
        root: createValueNOPSideEffects(),
        onEnd: () => { },
    };
}
exports.createDummyTypedHandler = createDummyTypedHandler;
