"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createExternalSchemaLoader = void 0;
const createSchemaHandler_1 = require("./createSchemaHandler");
function createExternalSchemaLoader($p) {
    let foundErrors = false;
    let schema = null;
    const spt = $p.$c.createTokenizer({
        parser: $p.$c.createStructureParser((0, createSchemaHandler_1.createSchemaHandler)($p.$c.getSchemaSchemaBuilder, () => {
            foundErrors = true;
            //console.error("SCHEMA ERROR", error)
        }, ($) => {
            schema = $;
        }, ($) => {
            return $p.$c.createLoggingTreeParser({
                handler: $,
                onError: () => {
                    foundErrors = true;
                },
            });
        }, $p.$c.createDummyTreeHandler)),
        onError: (_error) => {
            foundErrors = true;
        },
    });
    return {
        onData: ($) => {
            spt.onData($);
        },
        onEnd: () => {
            spt.onEnd(null);
            if (schema === null) {
                if (!foundErrors) {
                    throw new Error("no schema and no errors");
                }
                $p.$c.onError(["errors in external schema", {}]);
                $p.onFailed();
            }
            else {
                $p.onSucces(schema);
            }
        },
    };
}
exports.createExternalSchemaLoader = createExternalSchemaLoader;
