"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createHoverTextFinder = void 0;
const isPositionBeforeLocation_1 = require("./isPositionBeforeLocation");
const createHoverTextsGenerator_1 = require("./createHoverTextsGenerator");
function createHoverTextFinder(positionLine, //the line where the hover is requested
positionCharacter, //the character where the hover is requested
callback, getEndLocationFromRange) {
    return (0, createHoverTextsGenerator_1.createHoverTextsGenerator)((annotation, getHoverText) => {
        //console.log("LOCATION", range.start.line, range.start.column, range.end.line, range.end.column)
        if (!(0, isPositionBeforeLocation_1.isPositionBeforeLocation)({
            positionLine: positionLine,
            positionCharacter: positionCharacter,
            location: annotation.range.start,
        })) {
            if ((0, isPositionBeforeLocation_1.isPositionBeforeLocation)({
                positionLine: positionLine,
                positionCharacter: positionCharacter,
                location: getEndLocationFromRange(annotation.range),
            })) {
                if (getHoverText !== null) {
                    callback(getHoverText());
                }
            }
        }
    }, () => { });
}
exports.createHoverTextFinder = createHoverTextFinder;
