"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createHoverTextsGenerator = void 0;
const pr = __importStar(require("pareto-runtime"));
function createHoverTextsGenerator(onToken, onEnd) {
    function createValueHoverTextGenerator(name) {
        function addOnToken(token) {
            if (name !== null) {
                const cn = name;
                if (token !== null) {
                    onToken(token.annotation, () => {
                        return cn;
                    });
                }
            }
        }
        return {
            onDictionary: ($) => {
                addOnToken($.token);
                return {
                    onClose: ($) => {
                        addOnToken($.token);
                    },
                    onEntry: () => {
                        return createValueHoverTextGenerator(null);
                    },
                };
            },
            onList: ($) => {
                addOnToken($.token);
                return {
                    onClose: ($) => {
                        addOnToken($.token);
                    },
                    onElement: () => {
                        return createValueHoverTextGenerator(null);
                    },
                };
            },
            onTaggedUnion: ($) => {
                addOnToken($.token);
                return {
                    onUnexpectedOption: () => {
                        return createValueHoverTextGenerator(null);
                    },
                    onOption: ($) => {
                        addOnToken($.token);
                        return createValueHoverTextGenerator(null);
                    },
                    onEnd: () => { },
                };
            },
            onSimpleString: ($) => {
                addOnToken($.token);
            },
            onMultilineString: ($) => {
                addOnToken($.token);
            },
            onTypeReference: () => {
                return createValueHoverTextGenerator(name);
            },
            onGroup: ($) => {
                switch ($.type[0]) {
                    case "mixin":
                        break;
                    case "omitted":
                        break;
                    case "verbose":
                        pr.cc($.type[1], ($) => {
                            addOnToken($);
                        });
                        break;
                    case "shorthand":
                        pr.cc($.type[1], ($) => {
                            addOnToken($);
                        });
                        break;
                    default:
                        pr.au($.type[0]);
                }
                return {
                    onUnexpectedProperty: () => { },
                    onProperty: ($) => {
                        return createValueHoverTextGenerator($.key);
                    },
                    onClose: ($) => {
                        addOnToken($.token);
                    },
                };
            },
        };
    }
    return {
        root: createValueHoverTextGenerator(null),
        onEnd: () => {
            return onEnd();
        },
    };
}
exports.createHoverTextsGenerator = createHoverTextsGenerator;
