"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSchemaHandler = void 0;
function createSchemaHandler(getSchemaSchemaBuilder, onError, onSchema, createTreeParser, createDummyTreeHandler) {
    let foundError = false;
    let schemaDefinitionFound = false;
    let schemaSchemaBuilder = null;
    function onSchemaError() {
        onError();
        foundError = true;
    }
    function createDummyParser() {
        return createTreeParser(null); //creates parsing errors
    }
    return {
        onNoInternalSchema: () => { },
        onEmbeddedSchema: ($$) => {
            onSchemaError();
            return createDummyTreeHandler();
        },
        onSchemaReference: ($$) => {
            schemaDefinitionFound = true;
            schemaSchemaBuilder = getSchemaSchemaBuilder($$.token.token.value);
            if (schemaSchemaBuilder === null) {
                //console.error(`unknown schema schema '${schemaSchemaReference.data.value}'`)
                onSchemaError();
            }
        },
        onBody: () => {
            if (!schemaDefinitionFound) {
                //console.error("missing schema schema types")
                onSchemaError();
                return createDummyParser();
            }
            else {
                if (schemaSchemaBuilder === null) {
                    if (!foundError) {
                        throw new Error("UNEXPECTED: SCHEMA PROCESSOR NOT SUBSCRIBED AND NO ERRORS");
                    }
                    return createDummyParser();
                }
                else {
                    const x = createTreeParser(schemaSchemaBuilder((error, annotation2) => {
                        onError();
                    }, (schemaAndSideEffects) => {
                        onSchema(schemaAndSideEffects);
                    }));
                    return x;
                }
            }
        },
    };
}
exports.createSchemaHandler = createSchemaHandler;
