import { GroupDefinition, OptionDefinition, ValueDefinition } from "../../../typed/interface/interfaces/definitions";
import * as grammar from "../../../grammar/interface";
import * as etc from "../../../etc/interface";
import { UnmarshallError } from "../../../typed/interface/interfaces/UnmarshallError";
import { ITypedTaggedUnionHandler, ITypedValueHandler } from "../../../typed/interface/interfaces/ITypedTreeHandler";
import * as typed from "../../../typed/interface";
import * as t from "../../../typed/interface/interfaces/ITypedTreeHandler";
export declare type ValueContext<EventAnnotation> = {
    definition: typed.ValueDefinition;
    handler: t.ITypedValueHandler<EventAnnotation>;
};
export declare type IShorthandParsingState<EventAnnotation> = {
    wrapup(annotation: EventAnnotation, onError: (message: UnmarshallError, annotation: EventAnnotation, severity: etc.DiagnosticSeverity) => void): void;
    findNextValue(): ValueContext<EventAnnotation> | null;
    pushGroup(definition: typed.GroupDefinition, handler: t.ITypedValueHandler<EventAnnotation>): void;
    pushTaggedUnion(definition: typed.OptionDefinition, taggedUnionHandler: t.ITypedTaggedUnionHandler<EventAnnotation>, optionHandler: t.ITypedValueHandler<EventAnnotation>): void;
};
declare type OnError<EventAnnotation> = (message: UnmarshallError, annotation: EventAnnotation, severity: etc.DiagnosticSeverity) => void;
export declare function defaultInitializeValue<EventAnnotation>(definition: ValueDefinition, handler: ITypedValueHandler<EventAnnotation>, onError: OnError<EventAnnotation>): void;
declare type MixidIn<EventAnnotation> = {
    pushGroup: (definition: GroupDefinition, groupContainerHandler: ITypedValueHandler<EventAnnotation>) => grammar.IValueHandler<EventAnnotation>;
    pushTaggedUnion: (definition: OptionDefinition, taggedUnionHandler: ITypedTaggedUnionHandler<EventAnnotation>, optionHandler: ITypedValueHandler<EventAnnotation>) => void;
};
export declare type DummyHandlers<EventAnnotation> = {
    array: () => grammar.IArrayHandler<EventAnnotation>;
    object: () => grammar.IObjectHandler<EventAnnotation>;
    taggedUnion: () => grammar.ITaggedUnionHandler<EventAnnotation>;
    requiredValue: () => grammar.IRequiredValueHandler<EventAnnotation>;
};
export declare function createValueUnmarshaller<EventAnnotation>(definition: ValueDefinition, handler: ITypedValueHandler<EventAnnotation>, onError: OnError<EventAnnotation>, flagNonDefaultPropertiesFound: () => void, mixedIn: null | MixidIn<EventAnnotation>, dummyHandlers: DummyHandlers<EventAnnotation>): grammar.IValueHandler<EventAnnotation>;
export {};
