import { SerializationStyle } from "../../../typed/interface/interfaces/SerializationStyle";
import { InternalSchemaSpecification } from "../../../typed/interface/interfaces/InternalSchemaSpecification";
import * as def from "../../../typed/interface/interfaces/definitions";
import { IMarshallableDataset } from "../../../typed/interface/interfaces/IMarshallableDataset";
import { ContentToken } from "../../../grammar/interface/types/ContentToken";
import { CreateAnnotater } from "../../../grammar/interface/interfaces/CreateAnnotater";
import { CreateTreeParserAndHandleErrors } from "../../../astn/interface/interfaces/CreateTreeParser";
import { CreateASTNNormalizer } from "../../../astn/interface/interfaces/CreateASTNNormalizer";
import { TypeDefinition } from "../../../typed/interface/interfaces/definitions";
interface IOut<LeafEvent, BlockEvent> {
    sendEvent(event: LeafEvent): void;
    sendBlock(event: BlockEvent, callback: (out: IOut<LeafEvent, BlockEvent>) => void): void;
}
export declare type SerializeOut = IOut<ContentToken, {
    open: ContentToken;
    close: ContentToken;
}>;
export declare function marshallDataset(dataset: IMarshallableDataset, definition: TypeDefinition, out: SerializeOut, style: SerializationStyle): void;
export declare function marshall(dataset: IMarshallableDataset, schema: def.Schema, internalSchemaSpecification: InternalSchemaSpecification, style: SerializationStyle, writer: (str: string) => void, annotate: CreateAnnotater<null>, createTreeParser: CreateTreeParserAndHandleErrors<null>, createASTNNormalizer: CreateASTNNormalizer<null>): void;
export {};
