import { AnnotatedToken } from "./AnnotatedToken";
export declare type Wrapping = ["quote", {}] | ["apostrophe", {}] | ["none", {}];
export declare type SimpleStringData = {
    readonly "wrapping": Wrapping;
    readonly "value": string;
};
export declare type MultilineStringData = {
    readonly "lines": string[];
};
export declare type StructuralTokenType = ["tagged union start", {}] | ["open shorthand group", {}] | ["close shorthand group", {}] | ["open verbose group", {}] | ["close verbose group", {}] | ["open dictionary", {}] | ["close dictionary", {}] | ["open list", {}] | ["close list", {}];
export declare type StructuralTokenData = {
    readonly "type": StructuralTokenType;
};
export declare type ContentToken = ["structural", StructuralTokenData] | ["simple string", SimpleStringData] | ["multiline string", MultilineStringData];
export declare type AnnotatedContentToken<EventAnnotation> = AnnotatedToken<ContentToken, EventAnnotation>;
