"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createASTNSchemaBuilder = void 0;
const createASTNSchemaDeserializer_generated_1 = require("./createASTNSchemaDeserializer.generated"); //FIXME
function createASTNSchemaBuilder(createExpectContext, createDummyTypedHandler) {
    return (onError2, onSchema) => {
        let foundErrors = false;
        return (0, createASTNSchemaDeserializer_generated_1.createASTNSchemaDeserializer)(createExpectContext({
            issueHandler: ($) => {
                if ($.severity === ["error", {}]) {
                    onError2(["expect", $.issue], $.annotation);
                }
            },
            duplicateEntrySeverity: ["warning", {}],
            onDuplicateEntry: ["ignore", {}],
        }), (message, annotation) => {
            foundErrors = true;
            onError2(["validation", { message: message }], annotation);
        }, (schema) => {
            if (schema === null) {
                if (foundErrors === false) {
                    throw new Error("no schema, no errors");
                }
            }
            else {
                onSchema({
                    getSchema: () => schema,
                    createStreamingValidator: () => {
                        return createDummyTypedHandler();
                    },
                });
            }
        });
    };
}
exports.createASTNSchemaBuilder = createASTNSchemaBuilder;
