"use strict";
/*eslint
    "@typescript-eslint/no-unused-vars": 0,
    "@typescript-eslint/no-shadow": 0,
    "camelcase": 0,
    "dot-notation": 0,
    "no-underscore-dangle": 0,
    "quote-props": 0
*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createASTNSchemaDeserializer = void 0;
const pr = __importStar(require("pareto-runtime"));
function createASTNSchemaDeserializer(context, raiseValidationError, callback) {
    const resolveRegistry = pr.createResolveRegistry();
    function wrap(handler) {
        return {
            exists: handler,
            missing: () => { },
        };
    }
    function _generateHandler_root(callback) {
        return ((callback) => {
            let _root_type_v = null;
            const _types_v = pr.createDictionaryBuilder();
            return context.expectVerboseGroup({
                properties: {
                    "root type": {
                        onNotExists: () => { },
                        onExists: () => wrap(context.expectQuotedString({
                            warningOnly: true,
                            callback: ($) => {
                                _root_type_v = {
                                    annotation: $.token.annotation,
                                    value: $.token.token.value,
                                };
                            },
                        })),
                    },
                    "types": {
                        onNotExists: () => { },
                        onExists: () => wrap(context.expectDictionary({
                            onProperty: (propertyData) => {
                                return wrap(((callback) => {
                                    let _value_v = null;
                                    return context.expectVerboseGroup({
                                        properties: {
                                            "value": {
                                                onNotExists: () => { },
                                                onExists: () => wrap(_generateHandler_value((node) => _value_v = node, _types_v.toDictionary().getLookup())),
                                            },
                                        },
                                        onEnd: () => {
                                            if (_value_v === null) {
                                                _value_v = {
                                                    "type": ["simple string", {
                                                            "default value": "",
                                                            "quoted": true,
                                                        }],
                                                };
                                            }
                                            callback({
                                                "value": _value_v,
                                            });
                                        },
                                    });
                                })((node) => _types_v.add(propertyData.token.token.value, node)));
                            },
                        })),
                    },
                },
                onEnd: ($) => {
                    // if (_root_type_v === null) {
                    //     _root_type_v = ""
                    // }
                    callback({
                        "root type": pr.createReference("root type", _root_type_v, "root", $.annotation, _types_v.toDictionary().getLookup(), resolveRegistry.getRegistrater()),
                        "types": _types_v.toDictionary(),
                    });
                },
            });
        })((node) => callback(node));
    }
    function _generateHandler_simple_string(callback) {
        return ((callback) => {
            let _default_value_v = null;
            let _quoted_v = null;
            return context.expectVerboseGroup({
                properties: {
                    "default value": {
                        onNotExists: () => { },
                        onExists: () => wrap(context.expectQuotedString({
                            warningOnly: true,
                            callback: ($) => {
                                _default_value_v = $.token.token.value;
                            },
                        })),
                    },
                    "quoted": {
                        onNotExists: () => { },
                        onExists: () => wrap(context.expectTaggedUnion({
                            options: {
                                "yes": () => {
                                    return wrap(context.expectGroup({}));
                                },
                                "no": () => {
                                    _quoted_v = false;
                                    return wrap(context.expectGroup({}));
                                },
                            },
                        })),
                    },
                },
                onEnd: () => {
                    if (_default_value_v === null) {
                        _default_value_v = "";
                    }
                    if (_quoted_v === null) {
                        _quoted_v = true;
                    }
                    callback({
                        "default value": _default_value_v,
                        "quoted": _quoted_v,
                    });
                },
            });
        })((node) => callback(node));
    }
    function _generateHandler_value(callback, types) {
        return ((callback) => {
            let _type_v = null;
            return context.expectVerboseGroup({
                properties: {
                    "type": {
                        onNotExists: () => { },
                        onExists: () => wrap(context.expectTaggedUnion({
                            options: {
                                "dictionary": () => {
                                    return wrap(((callback) => {
                                        let _key_v = null;
                                        let _value_v = null;
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "key": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(_generateHandler_simple_string((node) => _key_v = node)),
                                                },
                                                "value": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(_generateHandler_value((node) => _value_v = node, types)),
                                                },
                                            },
                                            onEnd: () => {
                                                if (_key_v === null) {
                                                    _key_v = {
                                                        "default value": "",
                                                        "quoted": true,
                                                    };
                                                }
                                                if (_value_v === null) {
                                                    _value_v = {
                                                        "type": ["simple string", {
                                                                "default value": "",
                                                                "quoted": true,
                                                            }],
                                                    };
                                                }
                                                callback({
                                                    "key": _key_v,
                                                    "value": _value_v,
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["dictionary", node]));
                                },
                                "group": () => {
                                    return wrap(((callback) => {
                                        const _properties_v = pr.createDictionaryBuilder();
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "properties": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectDictionary({
                                                        onProperty: (propertyData) => {
                                                            return wrap(((callback) => {
                                                                let _value_v = null;
                                                                return context.expectVerboseGroup({
                                                                    properties: {
                                                                        "value": {
                                                                            onNotExists: () => { },
                                                                            onExists: () => wrap(_generateHandler_value((node) => _value_v = node, types)),
                                                                        },
                                                                    },
                                                                    onEnd: () => {
                                                                        if (_value_v === null) {
                                                                            _value_v = {
                                                                                "type": ["simple string", {
                                                                                        "default value": "",
                                                                                        "quoted": true,
                                                                                    }],
                                                                            };
                                                                        }
                                                                        callback({
                                                                            "value": _value_v,
                                                                        });
                                                                    },
                                                                });
                                                            })((node) => _properties_v.add(propertyData.token.token.value, node)));
                                                        },
                                                    })),
                                                },
                                            },
                                            onEnd: () => {
                                                callback({
                                                    "properties": _properties_v.toDictionary(),
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["group", node]));
                                },
                                "list": () => {
                                    return wrap(((callback) => {
                                        let _value_v = null;
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "value": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(_generateHandler_value((node) => _value_v = node, types)),
                                                },
                                            },
                                            onEnd: () => {
                                                if (_value_v === null) {
                                                    _value_v = {
                                                        "type": ["simple string", {
                                                                "default value": "",
                                                                "quoted": true,
                                                            }],
                                                    };
                                                }
                                                callback({
                                                    "value": _value_v,
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["list", node]));
                                },
                                "multiline string": () => {
                                    return wrap(((callback) => {
                                        return context.expectVerboseGroup({
                                            properties: {},
                                            onEnd: () => {
                                                callback({});
                                            },
                                        });
                                    })((node) => _type_v = ["multiline string", node]));
                                },
                                "simple string": () => {
                                    return wrap(((callback) => {
                                        let _default_value_v = null;
                                        let _quoted_v = null;
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "default value": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectQuotedString({
                                                        warningOnly: true,
                                                        callback: ($) => {
                                                            _default_value_v = $.token.token.value;
                                                        },
                                                    })),
                                                },
                                                "quoted": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectTaggedUnion({
                                                        options: {
                                                            "yes": () => {
                                                                return wrap(context.expectGroup({}));
                                                            },
                                                            "no": () => {
                                                                _quoted_v = false;
                                                                return wrap(context.expectGroup({}));
                                                            },
                                                        },
                                                    })),
                                                },
                                            },
                                            onEnd: () => {
                                                if (_default_value_v === null) {
                                                    _default_value_v = "";
                                                }
                                                if (_quoted_v === null) {
                                                    _quoted_v = true;
                                                }
                                                callback({
                                                    "default value": _default_value_v,
                                                    "quoted": _quoted_v,
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["simple string", node]));
                                },
                                "tagged union": () => {
                                    return wrap(((callback) => {
                                        let _default_option_v = null;
                                        const _options_v = pr.createDictionaryBuilder();
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "default option": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectQuotedString({
                                                        warningOnly: true,
                                                        callback: ($) => {
                                                            _default_option_v = {
                                                                value: $.token.token.value,
                                                                annotation: $.token.annotation,
                                                            };
                                                        },
                                                    })),
                                                },
                                                "options": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectDictionary({
                                                        onProperty: (propertyData) => {
                                                            return wrap(((callback) => {
                                                                let _value_v = null;
                                                                return context.expectVerboseGroup({
                                                                    properties: {
                                                                        "value": {
                                                                            onNotExists: () => { },
                                                                            onExists: () => wrap(_generateHandler_value((node) => _value_v = node, types)),
                                                                        },
                                                                    },
                                                                    onEnd: () => {
                                                                        if (_value_v === null) {
                                                                            _value_v = {
                                                                                "type": ["simple string", {
                                                                                        "default value": "",
                                                                                        "quoted": true,
                                                                                    }],
                                                                            };
                                                                        }
                                                                        callback({
                                                                            "value": _value_v,
                                                                        });
                                                                    },
                                                                });
                                                            })((node) => _options_v.add(propertyData.token.token.value, node)));
                                                        },
                                                    })),
                                                },
                                            },
                                            onEnd: ($) => {
                                                // if (_default_option_v === null) {
                                                //     _default_option_v = ""
                                                // }
                                                callback({
                                                    "default option": pr.createReference("default option", _default_option_v, "yes", $.annotation, _options_v.toDictionary().getLookup(), resolveRegistry.getRegistrater()),
                                                    "options": _options_v.toDictionary(),
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["tagged union", node]));
                                },
                                "type reference": () => {
                                    return wrap(((callback) => {
                                        let _type_v = null;
                                        return context.expectVerboseGroup({
                                            properties: {
                                                "type": {
                                                    onNotExists: () => { },
                                                    onExists: () => wrap(context.expectQuotedString({
                                                        warningOnly: true,
                                                        callback: ($) => {
                                                            _type_v = {
                                                                value: $.token.token.value,
                                                                annotation: $.token.annotation,
                                                            };
                                                        },
                                                    })),
                                                },
                                            },
                                            onEnd: ($) => {
                                                // if (_type_v === null) {
                                                //     _type_v = ""
                                                // }
                                                callback({
                                                    "type": pr.createReference("type", _type_v, "", $.annotation, types, resolveRegistry.getRegistrater()),
                                                });
                                            },
                                        });
                                    })((node) => _type_v = ["type reference", node]));
                                },
                            },
                        })),
                    },
                },
                onEnd: () => {
                    if (_type_v === null) {
                        _type_v = ["simple string", {
                                "default value": "",
                                "quoted": true,
                            }];
                    }
                    callback({
                        "type": _type_v,
                    });
                },
            });
        })((node) => callback(node));
    }
    return {
        "root": wrap(_generateHandler_root((root) => {
            const success = resolveRegistry.resolve((error) => {
                raiseValidationError(error.message, error.annotation);
            });
            if (success) {
                callback(root);
            }
            else {
                callback(null);
            }
        })),
        onEnd: () => { },
    };
}
exports.createASTNSchemaDeserializer = createASTNSchemaDeserializer;
