"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeSchema = void 0;
const pr = __importStar(require("pareto-runtime"));
function serializeSchema(schema, sendEvent) {
    function serializeDictionary(dict, entryCallback) {
        sendEvent(["structural", {
                "type": ["open dictionary", {}],
            }]);
        dict.forEach((entry, key) => {
            sendEvent(["simple string", {
                    value: key,
                    wrapping: ["quote", {}],
                }]);
            entryCallback(entry);
        });
        sendEvent(["structural", {
                "type": ["close dictionary", {}],
            }]);
    }
    function serializeVerboseType(properties) {
        sendEvent(["structural", {
                "type": ["open verbose group", {}],
            }]);
        pr.Objectkeys(properties).sort().forEach((key) => {
            sendEvent(["simple string", {
                    value: key,
                    wrapping: ["apostrophe", {}],
                }]);
            properties[key]();
        });
        sendEvent(["structural", {
                "type": ["close verbose group", {}],
            }]);
    }
    function serializeTaggedUnion(option, callback) {
        sendEvent(["structural", {
                "type": ["tagged union start", {}],
            }]);
        sendEvent(["simple string", {
                value: option,
                wrapping: ["apostrophe", {}],
            }]);
        callback();
    }
    function serializeQuotedString(value) {
        sendEvent(["simple string", {
                value: value,
                wrapping: ["quote", {}],
            }]);
    }
    function serializeReference(reference) {
        sendEvent(["simple string", {
                value: reference.name,
                wrapping: ["quote", {}],
            }]);
    }
    function serializeNonWrappedString(value) {
        sendEvent(["simple string", {
                value: value,
                wrapping: ["none", {}],
            }]);
    }
    function serializeValueDefinition(valueDefinition) {
        serializeVerboseType({
            type: () => {
                serializeTaggedUnion(valueDefinition.type[0], () => {
                    switch (valueDefinition.type[0]) {
                        case "dictionary": {
                            const $$ = valueDefinition.type[1];
                            serializeVerboseType({
                                "key": () => {
                                    serializeVerboseType({
                                        "default value": () => {
                                            serializeQuotedString($$.key["default value"]);
                                        },
                                        "quoted": () => {
                                            serializeNonWrappedString($$.key.quoted ? "true" : "false");
                                        },
                                    });
                                },
                                "value": () => {
                                    serializeValueDefinition($$.value);
                                },
                            });
                            break;
                        }
                        case "list": {
                            const $$ = valueDefinition.type[1];
                            serializeVerboseType({
                                "value": () => {
                                    serializeValueDefinition($$.value);
                                },
                            });
                            break;
                        }
                        case "type reference": {
                            const $ = valueDefinition.type[1];
                            serializeVerboseType({
                                type: () => {
                                    serializeReference($.type);
                                },
                            });
                            break;
                        }
                        case "tagged union": {
                            const $ = valueDefinition.type[1];
                            serializeVerboseType({
                                "default option": () => {
                                    serializeReference($["default option"]);
                                },
                                "options": () => {
                                    serializeDictionary($.options, (state) => {
                                        serializeVerboseType({
                                            node: () => serializeValueDefinition(state.value),
                                        });
                                    });
                                },
                            });
                            break;
                        }
                        case "simple string": {
                            const $ = valueDefinition.type[1];
                            serializeVerboseType({
                                "default value": () => {
                                    serializeQuotedString($["default value"]);
                                },
                                "quoted": () => {
                                    serializeNonWrappedString($.quoted ? "true" : "false");
                                },
                            });
                            break;
                        }
                        case "multiline string": {
                            //const $ = propDef.type[1]
                            serializeVerboseType({});
                            break;
                        }
                        case "group": {
                            const $ = valueDefinition.type[1];
                            serializeVerboseType({
                                properties: () => {
                                    serializeDictionary($.properties, ($) => {
                                        serializeValueDefinition($.value);
                                    });
                                },
                            });
                            break;
                        }
                        default:
                            pr.au(valueDefinition.type[0]);
                    }
                });
            },
        });
    }
    serializeVerboseType({
        "component types": () => {
            serializeDictionary(schema.types, (entry) => {
                serializeVerboseType({
                    node: () => serializeValueDefinition(entry.value),
                });
            });
        },
        "root type": () => {
            serializeReference(schema["root type"]);
        },
    });
}
exports.serializeSchema = serializeSchema;
